## FunctionalAnalysis_v2_Apr2019
## Teeratas Kijpornyongpan
## 4 Apr 2019
## This script is to perform functional analyses. For example, pull out

setwd("C:/Users/Teeratask/Documents/Aime's lab project/Dimorphism/Transcriptome_analyses/RNASeq_R_project")
##### Pull out eggNOG info from concordant result tables  #####
##Start by loading DGE list
## Three species comparison-Ustilaginomycotina ##
Ustilaginomycotina.concord.DEG <- read.table("../CompRNASeq_Results_v2_Apr2019/Ustilaginomycotina_concordantGenes.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##load annotation Tilwa.eggNOG
Tilwa.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Tilwa1_eggNOGformatted.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(Ustilaginomycotina.concord.DEG) ) {
  if ( length(unique(Tilwa.eggNOG$ProteinId == Ustilaginomycotina.concord.DEG$Tilwa.gene.id[i])) == 2  ) {
    Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == Ustilaginomycotina.concord.DEG$Tilwa.gene.id[i],c(1:4,6)])
  }
  else {
    Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, c(Tilwa.eggNOG$ProteinId[i],"0","0","0","0"))
  }
}
nrow(Tilwa.DE.eggNOG)
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)
##Count a number of genes in each KOG functional class
length(grep("A", Tilwa.DE.eggNOG$class)) ##Count a number of member in each class
class <- c("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
           "O", "P", "Q", "S", "T", "U", "V", "W", "Y", "Z")
number.gene.class <- data.frame()
for ( i in 1:length(class) ) {
  number.gene.class <- rbind(number.gene.class, cbind(class[i], length(grep(class[i], Tilwa.DE.eggNOG$class))))
}
number.gene.class <- data.frame() ##Go for DE.KOG.gene
for ( i in 1:length(class) ) {
  number.gene.class <- rbind(number.gene.class, cbind(class[i], length(grep(class[i], Tilwa.DE.eggNOG[Ustilaginomycotina.concord.DEG$padj < 0.01,]$class))))
}


##load annotation Ophnu.eggNOG
Ophnu.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Ophnu1_eggNOGformatted.txt", sep="\t", header=TRUE)
Ophnu.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Ophnu DEG list
for ( i in 1:nrow(Ustilaginomycotina.concord.DEG) ) {
  Ophnu.DE.eggNOG <- rbind(Ophnu.DE.eggNOG, Ophnu.eggNOG[Ophnu.eggNOG$ProteinId == Ustilaginomycotina.concord.DEG$Ophnu.gene.id[i],c(1:4,6)])
}
nrow(Ophnu.DE.eggNOG)
write.table(Ophnu.DE.eggNOG, file="Ophnu_DEG_eggNOG.txt", sep="\t", quote=FALSE)

MeimiTilwaOphnu.concord.DEG <- read.csv("../CompRNASeq_Results_v2_Apr2019/MeimiTilwaOphnu_concordantGenes.txt", sep="\t", header=TRUE)
##Then, load Ophnu annotation
Ophnu.eggNOG <- read.csv("../OrthoFinder_Jan2019/Ophnu1_eggNOGformatted.txt", sep="\t", header=TRUE)
Ophnu.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Ophnu DEG list
for ( i in 1:nrow(MeimiTilwaOphnu.concord.DEG) ) {
  Ophnu.DE.eggNOG <- rbind(Ophnu.DE.eggNOG, Ophnu.eggNOG[Ophnu.eggNOG$ProteinId == MeimiTilwaOphnu.concord.DEG$Ophnu.gene.id[i],c(1:4,6)])
}
nrow(Ophnu.DE.eggNOG)
write.table(Ophnu.DE.eggNOG, file="Ophnu_DEG_eggNOG.txt", sep="\t", quote=FALSE)

##Then, go for Canalb and Ophnu ##
CanalbOphnu.concord.DEG <- read.csv("Canalb_Ophnu_concordantGenes.txt", sep="\t", header=TRUE)
Ophnu.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Ophnu DEG list
for ( i in 1:nrow(CanalbOphnu.concord.DEG) ) {
  Ophnu.DE.eggNOG <- rbind(Ophnu.DE.eggNOG, Ophnu.eggNOG[Ophnu.eggNOG$ProteinId == CanalbOphnu.concord.DEG$Ophnu.gene.id[i],c(1:4,6)])
}
nrow(Ophnu.DE.eggNOG)
write.table(Ophnu.DE.eggNOG, file="Ophnu_DEG_eggNOG_withCanalb.txt", sep="\t", quote=FALSE)

##Then, go for four species##
##load annotation Ustma.eggNOG
Ustma.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Ustma2_eggNOGformatted.txt", sep="\t", header=TRUE)
Ustma.DE.eggNOG <- data.frame()

Fourspecies.concord.DEG <- read.csv("../CompRNASeq_Results_v2_Apr2019/FourSpeciesUstma_concordantGenes_p0.05.txt", sep="\t", header=TRUE)
Ustma.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Ustma DEG list
for ( i in 1:nrow(Fourspecies.concord.DEG) ) {
  Ustma.DE.eggNOG <- rbind(Ustma.DE.eggNOG, Ustma.eggNOG[Ustma.eggNOG$ProteinId == Fourspecies.concord.DEG$Ustma.gene.id[i],c(1:4,6)])
}
nrow(Ustma.DE.eggNOG)
write.table(Ustma.DE.eggNOG, file="Ustma_DEG_eggNOG_Fourspecies.txt", sep="\t", quote=FALSE)


##Find TilwaeggNOG ##
MeimiTilwa.concord.DEG <- read.csv("Meimi_Tilwa_concordantGenes.txt", sep="\t", header=TRUE)
Tilwa.eggNOG <- read.csv("../OrthoFinder_Jan2019/Tilwa1_eggNOGformatted.txt", sep="\t", header=TRUE)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(MeimiTilwa.concord.DEG) ) {
  Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == MeimiTilwa.concord.DEG$Tilwa.gene.id[i],c(1:4,6)])
}
Tilwa.DE.eggNOG
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)

##### What about pulling out annotation results from Ustilago.concord that comes from data points overlaying on the plots  #####
##Start from the ones overlayed on Tollot and Lanver
head(Ustilago.Tollot.concord)
Tilwa.eggNOG <- read.csv("../OrthoFinder_Jan2019/Tilwa1_eggNOGformatted.txt", sep="\t", header=TRUE)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(Ustilago.Tollot.concord) ) {
  Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == Ustilago.Tollot.concord$Tilwa[i],c(1:4,6)])
}
nrow(Tilwa.DE.eggNOG)
Tilwa.DE.eggNOG <- cbind(Ustilago.Tollot.concord, Tilwa.DE.eggNOG)
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)

head(Ustilago.Lanver.concord)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(Ustilago.Lanver.concord) ) {
  Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == Ustilago.Lanver.concord$Tilwa[i],c(1:4,6)])
}
nrow(Tilwa.DE.eggNOG)  
nrow(Ustilago.Lanver.concord) ##Row names are not equal
Tilwa.DE.eggNOG$ProteinId == Ustilago.Lanver.concord$Tilwa ##Element 45 is missing in Tilwa.DE.eggNOG
filler <- cbind(NA, NA, NA, NA, NA)
colnames(filler) <- c("ProteinId", "euNOG", "fuNOG", "class", "function.")
Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG[1:44,], filler, Tilwa.DE.eggNOG[45:nrow(Tilwa.DE.eggNOG),])
Tilwa.DE.eggNOG <- cbind(Ustilago.Lanver.concord, Tilwa.DE.eggNOG)
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)

head(Ustilago.PaulUmp2.concord)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(Ustilago.PaulUmp2.concord) ) {
  Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == Ustilago.PaulUmp2.concord$Tilwa[i],c(1:4,6)])
}
nrow(Tilwa.DE.eggNOG)
nrow(Ustilago.PaulUmp2.concord) ##Row names are not equal
Tilwa.DE.eggNOG$ProteinId == Ustilago.PaulUmp2.concord$Tilwa ##Element 10 is missing in Tilwa.DE.eggNOG
filler <- cbind(NA, NA, NA, NA, NA)
colnames(filler) <- c("ProteinId", "euNOG", "fuNOG", "class", "function.")
Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG[1:36,], filler, Tilwa.DE.eggNOG[37:nrow(Tilwa.DE.eggNOG),])
Tilwa.DE.eggNOG <- cbind(Ustilago.PaulUmp2.concord, Tilwa.DE.eggNOG)
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)
sort(intersect(Ustilago.PaulUmp2.concord$Ustma, Ustilago.PaulN.concord$Ustma)) ##31 genes

head(Ustilago.Dikaryon2.concord)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(Ustilago.Dikaryon2.concord) ) {
  Tilwa.DE.eggNOG <- rbind(Tilwa.DE.eggNOG, Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == Ustilago.Dikaryon2.concord$Tilwa[i],c(1:4,6)])
}
nrow(Tilwa.DE.eggNOG)
nrow(Ustilago.Dikaryon2.concord) ##Row names are equal
Tilwa.DE.eggNOG <- cbind(Ustilago.Dikaryon2.concord, Tilwa.DE.eggNOG)
write.table(Tilwa.DE.eggNOG, file="Tilwa_DEG_eggNOG.txt", sep="\t", quote=FALSE)
sort(intersect(Ustilago.Dikaryon1.concord$Ustma, Ustilago.Dikaryon2.concord$Ustma)) ##31 genes

#####Finally, perform Venn diagrams #####
## Start from Meimi and Tilwa: 338 concordant, 493 discordant, 543 only Tilwa, 744 only Meimi, 535 non.DEG
library(ggplot2)
#install.packages("ggforce")
library(ggforce)
df.venn <- data.frame(x = c(0, 0.866, -0.866),
                      y = c(1, -0.5, -0.5),
                      labels = c('A', 'B', 'C'))
ggplot(df.venn, aes(x0 = x, y0 = y, r = 1.5, fill = labels)) +
  geom_circle(alpha = .3, size = 1, colour = 'grey') +
  coord_fixed() +
  theme_void()

###################################################
##### Code chunk: Hypergeometric test for KOG classification version1 #####
###################################################
##Have input as a list of known orthogroups, and a number of whether DE or not and whether KOG.interest or not
##Start by reading an input in a table format showing four different values: Total.genes, Total.DE, Total.KOG and DE.KOG
##Then loop for each class and perform hypergeometric test by one-way Fisher-Exact test
KOG.count.input <- read.table(file="Input_KOGHypergeo.txt", header=TRUE, sep="\t", stringsAsFactors = FALSE)
head(KOG.count.input)
KOG.enrich.results <- data.frame()
for ( i in 1:nrow(KOG.count.input) ) {
  Total.genes <- KOG.count.input$Total.genes[i]; Total.DE <- KOG.count.input$Total.DE[i]
  Total.KOG <- KOG.count.input$Total.KOG[i]; DE.KOG <- KOG.count.input$DE.KOG[i]
  DE.only.count <- Total.DE - DE.KOG
  KOG.only.count <- Total.KOG - DE.KOG
  neither.count <- Total.genes - DE.only.count - KOG.only.count
  both.count <- DE.KOG
  temp.mat <- matrix(c(neither.count, KOG.only.count, DE.only.count, both.count),ncol=2,byrow=F)
  temp.test <- fisher.test(temp.mat, alternative="greater")
  KOG.enrich.results <- rbind(KOG.enrich.results , cbind( KOG.count.input$KOG.class[i], temp.test$estimate, temp.test$p.value))
}
colnames(KOG.enrich.results) <- c("Class", "Odd.ratio", "p.value")
KOG.enrich.results
write.table(KOG.enrich.results, file="KOG_HypergeometricResults.txt", quote=FALSE, sep="\t", row.names = FALSE)

##### Pull out known genes for fungal dimorphism #####
dimorphism.list <- read.table(file="Input_dimorphism.txt", sep="\t", header=TRUE)
head(dimorphism.list)
##Load DEG table of each species, and check if they are DE
Meimi.DEG <- read.csv("../Ust_Illumina/Results_v1/Meimi_DESeq2Results_sorted.csv", header=TRUE)
colnames(Meimi.DEG)[1] <- "gene.id"
##I think we need only gene.id, log2FoldChange and p-value, both raw and adjusted
Meimi.DEG <- Meimi.DEG[, c(1,3,6,7)]
head(Meimi.DEG)
dim(Meimi.DEG)   ## 7400 genes

##Make a loop to retrieve only known dimorphism genes of interest
dimorphic.interest <- data.frame()
for ( i in 1:nrow(dimorphism.list) ) {
  if ( dimorphism.list$Meimi[i] == 0 ) { next }
  if ( length(unique(Meimi.DEG$gene.id == dimorphism.list$Meimi[i])) == 2 ) { 
    Meimi.interest <- Meimi.DEG[which(Meimi.DEG$gene.id == dimorphism.list$Meimi[i]),]
    dimorphic.interest <- rbind(dimorphic.interest, cbind(dimorphism.list$OG_number[i], Meimi.interest))
  }
}
dimorphic.interest[dimorphic.interest$padj < 0.05,]
dimorphic.interest[dimorphic.interest$padj < 0.05 & dimorphic.interest$log2FoldChange > 0,-4]
dimorphic.interest[dimorphic.interest$padj < 0.05 & dimorphic.interest$log2FoldChange < 0,-4]
write.table(dimorphic.interest, file="dimorphicGene_DESeq2Results.txt", sep="\t", quote=FALSE, row.names = FALSE)

###################################################
##### Perform randomization for hypergeometric test from multispecies RNASeq version2#####
##Attempt to perform Hypergeometric tests among genes that are DE in all species, to see if we see any functional enrichment.
##As whether genes in each species are DE or not is an independent event, 4 independent events. And then we will check for a coincidence
##Regular hypergeometric distribution may not be enough. Propably I should generate a nul distribution by myself
##To do this: we have known number of total orthgroups, number of DE genes in each species, number of genes in each functional class
##Will randomize a number of DE gene in certain functional class.
##Steps: fix position of functional class, randomize DE for each species, look for genes DE in all species, record number of all DE genes that falls
##into the class of interest. Finally, check with our own data

##Start with two species: Meimi and Tilwa
##Import comparative transcriptomics table, as well as functional class annotation
MeimiTilwa.DE.Table <- read.table("../CompRNASeq_Results_v2_Apr2019/MeimiTilwa_allgenes.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##Extract info needed. Total number of orthogroups, number of DE, number of DE up and DE down
num.orthogroup <- nrow(MeimiTilwa.DE.Table)
num.Meimi.DE <- nrow( subset(MeimiTilwa.DE.Table, Meimi.padj < 0.01) )
num.Meimi.DE.up <- nrow( subset(MeimiTilwa.DE.Table, Meimi.padj < 0.01 & Meimi.log2FC > 0) )
num.Meimi.DE.down <- nrow( subset(MeimiTilwa.DE.Table, Meimi.padj < 0.01 & Meimi.log2FC < 0) )
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Meimi.log2FC > 0 & MeimiTilwa.DE.Table$Meimi.padj < 0.01, 3] <- 1
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Meimi.padj >= 0.01, 3] <- 0
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Meimi.log2FC < 0 & MeimiTilwa.DE.Table$Meimi.padj < 0.01, 3] <- -1

num.Tilwa.DE <- nrow( subset(MeimiTilwa.DE.Table, Tilwa.padj < 0.01) )
num.Tilwa.DE.up <- nrow( subset(MeimiTilwa.DE.Table, Tilwa.padj < 0.01 & Tilwa.log2FC > 0) )
num.Tilwa.DE.down <- nrow( subset(MeimiTilwa.DE.Table, Tilwa.padj < 0.01 & Tilwa.log2FC < 0) )
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Tilwa.log2FC > 0 & MeimiTilwa.DE.Table$Tilwa.padj < 0.01, 7] <- 1
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Tilwa.padj >= 0.01, 7] <- 0
MeimiTilwa.DE.Table[ MeimiTilwa.DE.Table$Tilwa.log2FC < 0 & MeimiTilwa.DE.Table$Tilwa.padj < 0.01, 7] <- -1
##Select only columns needed for the analysis
MeimiTilwa.DE.Table <- MeimiTilwa.DE.Table[,c(2,3,6,7)]
rownames(MeimiTilwa.DE.Table) <- 1:nrow(MeimiTilwa.DE.Table)
colnames(MeimiTilwa.DE.Table)[1:4] <- c("Meimi.gene.id", "Meimi.DE", "Tilwa.gene.id", "Tilwa.DE")

##Add functional class on it
MeimiTilwa.DE.Table$Class <- "0"
head(MeimiTilwa.DE.Table)

##load annotation Tilwa.eggNOG
Tilwa.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Tilwa1_eggNOGformatted.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
Tilwa.DE.eggNOG <- data.frame()
##Work as a loop to add-on the eggNOG info for each of Tilwa DEG list
for ( i in 1:nrow(MeimiTilwa.DE.Table) ) {
  if ( length(unique(Tilwa.eggNOG$ProteinId == MeimiTilwa.DE.Table$Tilwa.gene.id[i])) == 2  ) {
    if ( Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == MeimiTilwa.DE.Table$Tilwa.gene.id[i],4] == "" ) {
      MeimiTilwa.DE.Table[i,5] <- "0"
    }
    MeimiTilwa.DE.Table[i,5] <- Tilwa.eggNOG[Tilwa.eggNOG$ProteinId == MeimiTilwa.DE.Table$Tilwa.gene.id[i],4]
  }
}

num.all.DE <- nrow(MeimiTilwa.DE.Table[MeimiTilwa.DE.Table$Meimi.DE != 0 & MeimiTilwa.DE.Table$Tilwa.DE != 0 ,])
##Then, count a number of genes in each functional class
length(grep("A", MeimiTilwa.DE.Table$Class)) ##Count a number of member in each class
class <- c("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
           "O", "P", "Q", "S", "T", "U", "V", "W", "Y", "Z")
num.class.all <- vector()
for ( i in 1:length(class) ) {
  num.class.all <- c(num.class.all, length(grep(class[i], MeimiTilwa.DE.Table$Class)))
  names(num.class.all)[i] <-  class[i]
}
num.class.all
##After that, count a number of concordantly DE genes in each class
num.class.DE <- vector()
for ( i in 1:length(class) ) {
  num.class.DE <- c(num.class.DE, length(grep(class[i], MeimiTilwa.DE.Table[MeimiTilwa.DE.Table$Meimi.DE != 0 &
                                                                              MeimiTilwa.DE.Table$Tilwa.DE != 0,]$Class)))
  names(num.class.DE)[i] <-  class[i]
}
num.class.DE
##Calculate odd ratio in each class: For real dataset
class.odd.ratio <- vector()
for ( i in 1:length(class) ) {
  num.class.nonDE <- num.class.all[i]-num.class.DE[i]
  num.nonclass.DE <- num.all.DE-num.class.DE[i]
  num.nonclass.nonDE <- num.orthogroup - num.class.DE[i] - num.class.nonDE - num.nonclass.DE
  class.odd.ratio <- c(class.odd.ratio, (num.class.DE[i]/num.class.nonDE)/(num.nonclass.DE/num.nonclass.nonDE))
  names(num.class.DE)[i] <-  class[i]
}
class.odd.ratio

##After that, perform a loop to do randomization. Create a loop for 1000 times
random.num.class.DE <- data.frame()
random.MeimiTilwa.DE.Table <- MeimiTilwa.DE.Table
for ( i in 1:999 ) {
  random.MeimiTilwa.DE.Table$Meimi.DE <- sample(MeimiTilwa.DE.Table$Meimi.DE, nrow(MeimiTilwa.DE.Table), replace = FALSE)
  random.MeimiTilwa.DE.Table$Tilwa.DE <- sample(MeimiTilwa.DE.Table$Tilwa.DE, nrow(MeimiTilwa.DE.Table), replace = FALSE)
  mock.num.class.DE <- vector()
  for ( i in 1:length(class) ) {
    mock.num.class.DE <- c(mock.num.class.DE, length(grep(class[i], random.MeimiTilwa.DE.Table[random.MeimiTilwa.DE.Table$Meimi.DE != 0 &
                                                                                random.MeimiTilwa.DE.Table$Tilwa.DE != 0,]$Class)))
    names(mock.num.class.DE)[i] <-  class[i]
  }
  random.num.class.DE <- rbind(random.num.class.DE, mock.num.class.DE)
}
colnames(random.num.class.DE) <- class
head(random.num.class.DE)
class.p.value <- vector()
for ( i in 1:length(class) ) {
  class.p.value <- c(class.p.value, length(which(random.num.class.DE[,i] > num.class.DE[i]))/1000)
  names(class.p.value)[i] <-  class[i]
}
##Write a summary table for class, num.class.all, num.class.DE, odd.ratio and p.value
cbind(num.class.all, num.class.DE, class.odd.ratio, class.p.value)
write.table(cbind(num.class.all, num.class.DE, class.odd.ratio, class.p.value), file="Hypergeometric_summary.txt", sep="\t", quote=FALSE)
hist(random.num.class.DE$E, nclass=20)

#####Then, go for three species: Meimi, Tilwa and Ustma#####
##Import comparative transcriptomics table, as well as functional class annotation
Ustilaginomycotina.DE.Table <- read.table("../CompRNASeq_Results_v2_Apr2019/Ustilaginomycotina_allgenes.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##Extract total number of orthogroups, reassign up/down/non-DE as a sign +, - and 0
num.orthogroup <- nrow(Ustilaginomycotina.DE.Table)
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Meimi.log2FC > 0 & Ustilaginomycotina.DE.Table$Meimi.padj < 0.05, 3] <- 1
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Meimi.padj >= 0.05 | is.na(Ustilaginomycotina.DE.Table$Meimi.padj), 3] <- 0
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Meimi.log2FC < 0 & Ustilaginomycotina.DE.Table$Meimi.padj < 0.05, 3] <- -1
  Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Tilwa.log2FC > 0 & Ustilaginomycotina.DE.Table$Tilwa.padj < 0.05, 8] <- 1
  Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Tilwa.padj >= 0.05 | is.na(Ustilaginomycotina.DE.Table$Tilwa.padj), 8] <- 0
  Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Tilwa.log2FC < 0 & Ustilaginomycotina.DE.Table$Tilwa.padj < 0.05, 8] <- -1
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Ustma.log2FC > 0 & Ustilaginomycotina.DE.Table$Ustma.padj < 0.05, 13] <- 1
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Ustma.padj >= 0.05 | is.na(Ustilaginomycotina.DE.Table$Ustma.padj), 13] <- 0
Ustilaginomycotina.DE.Table[ Ustilaginomycotina.DE.Table$Ustma.log2FC < 0 & Ustilaginomycotina.DE.Table$Ustma.padj < 0.05, 13] <- -1
##Select only columns needed for the analysis
Ustilaginomycotina.DE.Table <- Ustilaginomycotina.DE.Table[,c(2,3,7,8,12,13)]
rownames(Ustilaginomycotina.DE.Table) <- 1:nrow(Ustilaginomycotina.DE.Table)
colnames(Ustilaginomycotina.DE.Table)[1:6] <- c("Meimi.gene.id", "Meimi.DE", "Tilwa.gene.id", "Tilwa.DE", "Ustma.gene.id", "Ustma.DE")
##Add functional class on it
Ustilaginomycotina.DE.Table$Class <- "0"
head(Ustilaginomycotina.DE.Table)
##load annotation Ustma.eggNOG
Ustma.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Ustma2_eggNOGformatted.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##Work as a loop to add-on the eggNOG info for each of Ustma DEG list
for ( i in 1:nrow(Ustilaginomycotina.DE.Table) ) {
  if ( length(unique(Ustma.eggNOG$ProteinId == Ustilaginomycotina.DE.Table$Ustma.gene.id[i])) == 2  ) {
    if ( Ustma.eggNOG[Ustma.eggNOG$ProteinId == Ustilaginomycotina.DE.Table$Ustma.gene.id[i],4] == "" ) {
      Ustilaginomycotina.DE.Table[i,ncol(Ustilaginomycotina.DE.Table)] <- "0"
    }
    Ustilaginomycotina.DE.Table[i,ncol(Ustilaginomycotina.DE.Table)] <- Ustma.eggNOG[Ustma.eggNOG$ProteinId == Ustilaginomycotina.DE.Table$Ustma.gene.id[i],4]
  }
}
num.all.DE <- nrow(Ustilaginomycotina.DE.Table[Ustilaginomycotina.DE.Table$Meimi.DE != 0 & Ustilaginomycotina.DE.Table$Tilwa.DE != 0 
                                               & Ustilaginomycotina.DE.Table$Ustma.DE != 0,])
##Then, count a number of genes in each functional class
length(grep("A", Ustilaginomycotina.DE.Table$Class)) ##Count a number of member in each class
class <- c("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
           "O", "P", "Q", "S", "T", "U", "V", "W", "Y", "Z")
num.class.all <- vector()
for ( i in 1:length(class) ) {
  num.class.all <- c(num.class.all, length(grep(class[i], Ustilaginomycotina.DE.Table$Class)))
  names(num.class.all)[i] <-  class[i]
}
num.class.all
##After that, count a number of concordantly DE genes in each class
num.class.DE <- vector()
for ( i in 1:length(class) ) {
  num.class.DE <- c(num.class.DE, length(grep(class[i], Ustilaginomycotina.DE.Table[Ustilaginomycotina.DE.Table$Meimi.DE != 0 &
                                                        Ustilaginomycotina.DE.Table$Tilwa.DE != 0 & Ustilaginomycotina.DE.Table$Ustma.DE != 0 ,]$Class)))
  names(num.class.DE)[i] <-  class[i]
}
num.class.DE
##Calculate odd ratio in each class: For real dataset
class.odd.ratio <- vector()
for ( i in 1:length(class) ) {
  num.class.nonDE <- num.class.all[i]-num.class.DE[i]
  num.nonclass.DE <- num.all.DE-num.class.DE[i]
  num.nonclass.nonDE <- num.orthogroup - num.class.DE[i] - num.class.nonDE - num.nonclass.DE
  class.odd.ratio <- c(class.odd.ratio, (num.class.DE[i]/num.class.nonDE)/(num.nonclass.DE/num.nonclass.nonDE))
  names(num.class.DE)[i] <-  class[i]
}
class.odd.ratio
##After that, perform a loop to do randomization. Create a loop for 1000 times
random.num.class.DE <- data.frame()
random.Ustilaginomycotina.DE.Table <- Ustilaginomycotina.DE.Table
for ( i in 1:999 ) {
  random.Ustilaginomycotina.DE.Table$Meimi.DE <- sample(Ustilaginomycotina.DE.Table$Meimi.DE, nrow(Ustilaginomycotina.DE.Table), replace = FALSE)
  random.Ustilaginomycotina.DE.Table$Tilwa.DE <- sample(Ustilaginomycotina.DE.Table$Tilwa.DE, nrow(Ustilaginomycotina.DE.Table), replace = FALSE)
  random.Ustilaginomycotina.DE.Table$Ustma.DE <- sample(Ustilaginomycotina.DE.Table$Ustma.DE, nrow(Ustilaginomycotina.DE.Table), replace = FALSE)
  mock.num.class.DE <- vector()
  for ( i in 1:length(class) ) {
    mock.num.class.DE <- c(mock.num.class.DE, length(grep(class[i], random.Ustilaginomycotina.DE.Table[random.Ustilaginomycotina.DE.Table$Meimi.DE != 0 &
                                                     random.Ustilaginomycotina.DE.Table$Tilwa.DE != 0 & random.Ustilaginomycotina.DE.Table$Ustma.DE != 0,]$Class)))
    names(mock.num.class.DE)[i] <-  class[i]
  }
  random.num.class.DE <- rbind(random.num.class.DE, mock.num.class.DE)
}
colnames(random.num.class.DE) <- class
head(random.num.class.DE)
class.p.value <- vector()
for ( i in 1:length(class) ) {
  class.p.value <- c(class.p.value, length(which(random.num.class.DE[,i] > num.class.DE[i]))/1000)
  names(class.p.value)[i] <-  class[i]
}
class.p.value
hist(random.num.class.DE$M, nclass=20)
##Write a summary table for class, num.class.all, num.class.DE, odd.ratio and p.value
write.table(cbind(num.class.all, num.class.DE, class.odd.ratio, class.p.value), file="Hypergeometric_summary.txt", sep="\t", quote=FALSE)

#####Then, go for four species: Meimi, Tilwa, Ustma and Ophnu#####
##Import comparative transcriptomics table, as well as functional class annotation
FourSpecies.DE.Table <- read.table("../CompRNASeq_Results_v2_Apr2019/FourSpecies_allgenes.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##Extract total number of orthogroups, reassign up/down/non-DE as a sign +, - and 0
num.orthogroup <- nrow(FourSpecies.DE.Table)
FourSpecies.DE.Table[ FourSpecies.DE.Table$Meimi.log2FC > 0 & FourSpecies.DE.Table$Meimi.padj < 0.05, 3] <- 1
FourSpecies.DE.Table[ FourSpecies.DE.Table$Meimi.padj >= 0.05 | is.na(FourSpecies.DE.Table$Meimi.padj), 3] <- 0
FourSpecies.DE.Table[ FourSpecies.DE.Table$Meimi.log2FC < 0 & FourSpecies.DE.Table$Meimi.padj < 0.05, 3] <- -1
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Tilwa.log2FC > 0 & FourSpecies.DE.Table$Tilwa.padj < 0.05, 8] <- 1
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Tilwa.padj >= 0.05 | is.na(FourSpecies.DE.Table$Tilwa.padj), 8] <- 0
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Tilwa.log2FC < 0 & FourSpecies.DE.Table$Tilwa.padj < 0.05, 8] <- -1
FourSpecies.DE.Table[ FourSpecies.DE.Table$Ustma.log2FC > 0 & FourSpecies.DE.Table$Ustma.padj < 0.05, 13] <- 1
FourSpecies.DE.Table[ FourSpecies.DE.Table$Ustma.padj >= 0.05 | is.na(FourSpecies.DE.Table$Ustma.padj), 13] <- 0
FourSpecies.DE.Table[ FourSpecies.DE.Table$Ustma.log2FC < 0 & FourSpecies.DE.Table$Ustma.padj < 0.05, 13] <- -1
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Ophnu.log2FC > 0 & FourSpecies.DE.Table$Ophnu.padj < 0.05, 18] <- 1
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Ophnu.padj >= 0.05 | is.na(FourSpecies.DE.Table$Ophnu.padj), 18] <- 0
  FourSpecies.DE.Table[ FourSpecies.DE.Table$Ophnu.log2FC < 0 & FourSpecies.DE.Table$Ophnu.padj < 0.05, 18] <- -1
##Select only columns needed for the analysis
FourSpecies.DE.Table <- FourSpecies.DE.Table[,c(2,3,7,8,12,13,17,18)]
rownames(FourSpecies.DE.Table) <- 1:nrow(FourSpecies.DE.Table)
colnames(FourSpecies.DE.Table)[1:8] <- c("Meimi.gene.id", "Meimi.DE", "Tilwa.gene.id", "Tilwa.DE", "Ophnu.gene.id", "Ophnu.DE", "Ustma.gene.id", "Ustma.DE")
##Add functional class on it
FourSpecies.DE.Table$Class <- "0"
head(FourSpecies.DE.Table)
##load annotation Ustma.eggNOG
Ustma.eggNOG <- read.csv("../OrthoFinder_Jan2019/eggNOG annotation/Ustma2_eggNOGformatted.txt", sep="\t", header=TRUE, stringsAsFactors = FALSE)
##Work as a loop to add-on the eggNOG info for each of Ustma DEG list
for ( i in 1:nrow(FourSpecies.DE.Table) ) {
  if ( length(unique(Ustma.eggNOG$ProteinId == FourSpecies.DE.Table$Ustma.gene.id[i])) == 2  ) {
    if ( Ustma.eggNOG[Ustma.eggNOG$ProteinId == FourSpecies.DE.Table$Ustma.gene.id[i],4] == "" ) {
      FourSpecies.DE.Table[i,ncol(FourSpecies.DE.Table)] <- "0"
    }
    FourSpecies.DE.Table[i,ncol(FourSpecies.DE.Table)] <- Ustma.eggNOG[Ustma.eggNOG$ProteinId == FourSpecies.DE.Table$Ustma.gene.id[i],4]
  }
}
num.all.DE <- nrow(FourSpecies.DE.Table[FourSpecies.DE.Table$Meimi.DE != 0 & FourSpecies.DE.Table$Tilwa.DE != 0 & FourSpecies.DE.Table$Ophnu.DE != 0
                                        & FourSpecies.DE.Table$Ustma.DE != 0,])
##Then, count a number of genes in each functional class
length(grep("A", FourSpecies.DE.Table$Class)) ##Count a number of member in each class
class <- c("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
           "O", "P", "Q", "S", "T", "U", "V", "W", "Y", "Z")
num.class.all <- vector()
for ( i in 1:length(class) ) {
  num.class.all <- c(num.class.all, length(grep(class[i], FourSpecies.DE.Table$Class)))
  names(num.class.all)[i] <-  class[i]
}
num.class.all
##After that, count a number of concordantly DE genes in each class
num.class.DE <- vector()
for ( i in 1:length(class) ) {
  num.class.DE <- c(num.class.DE, length(grep(class[i], FourSpecies.DE.Table[FourSpecies.DE.Table$Meimi.DE != 0 & FourSpecies.DE.Table$Tilwa.DE != 0
                                                            & FourSpecies.DE.Table$Ophnu.DE != 0 & FourSpecies.DE.Table$Ustma.DE != 0 ,]$Class)))
  names(num.class.DE)[i] <-  class[i]
}
num.class.DE
##Calculate odd ratio in each class: For real dataset
class.odd.ratio <- vector()
for ( i in 1:length(class) ) {
  num.class.nonDE <- num.class.all[i]-num.class.DE[i]
  num.nonclass.DE <- num.all.DE-num.class.DE[i]
  num.nonclass.nonDE <- num.orthogroup - num.class.DE[i] - num.class.nonDE - num.nonclass.DE
  class.odd.ratio <- c(class.odd.ratio, (num.class.DE[i]/num.class.nonDE)/(num.nonclass.DE/num.nonclass.nonDE))
  names(num.class.DE)[i] <-  class[i]
}
class.odd.ratio
##After that, perform a loop to do randomization. Create a loop for 1000 times
random.num.class.DE <- data.frame()
random.FourSpecies.DE.Table <- FourSpecies.DE.Table
for ( i in 1:999 ) {
  random.FourSpecies.DE.Table$Meimi.DE <- sample(FourSpecies.DE.Table$Meimi.DE, nrow(FourSpecies.DE.Table), replace = FALSE)
  random.FourSpecies.DE.Table$Tilwa.DE <- sample(FourSpecies.DE.Table$Tilwa.DE, nrow(FourSpecies.DE.Table), replace = FALSE)
  random.FourSpecies.DE.Table$Ustma.DE <- sample(FourSpecies.DE.Table$Ustma.DE, nrow(FourSpecies.DE.Table), replace = FALSE)
  random.FourSpecies.DE.Table$Ophnu.DE <- sample(FourSpecies.DE.Table$Ophnu.DE, nrow(FourSpecies.DE.Table), replace = FALSE)
  mock.num.class.DE <- vector()
  for ( i in 1:length(class) ) {
    mock.num.class.DE <- c(mock.num.class.DE, length(grep(class[i], random.FourSpecies.DE.Table[random.FourSpecies.DE.Table$Meimi.DE != 0 & random.FourSpecies.DE.Table$Tilwa.DE != 0
                                                                                                          & random.FourSpecies.DE.Table$Ophnu.DE != 0 & random.FourSpecies.DE.Table$Ustma.DE != 0,]$Class)))
    names(mock.num.class.DE)[i] <-  class[i]
  }
  random.num.class.DE <- rbind(random.num.class.DE, mock.num.class.DE)
}
colnames(random.num.class.DE) <- class
head(random.num.class.DE)
class.p.value <- vector()
for ( i in 1:length(class) ) {
  class.p.value <- c(class.p.value, length(which(random.num.class.DE[,i] > num.class.DE[i]))/1000)
  names(class.p.value)[i] <-  class[i]
}
class.p.value
hist(random.num.class.DE$Z, nclass=20)
##Write a summary table for class, num.class.all, num.class.DE, odd.ratio and p.value
write.table(cbind(num.class.all, num.class.DE, class.odd.ratio, class.p.value), file="Hypergeometric_summary.txt", sep="\t", quote=FALSE)

